#include <htc.h>
#include <stdio.h>
#include <string.h>

__CONFIG(INTIO & BORDIS	& WDTDIS & UNPROTECT & MCLRDIS & PWRTEN);

#define TRIG	GPIO5			
#define ECHO	GPIO5			
#define Tx		GPIO2
#define IN		TRIS5=1
#define OUT		TRIS5=0

void send_pulse(void);
void delay_104us(void);
void Soft_USART_Init(void);
unsigned int get_srf05(void);
void Soft_USART_Write(unsigned char data);


void main(void){
unsigned char j;
unsigned int b;
char envio[10];

	ANSEL=0;
	CMCON=0x07;
	GPIO=0;
	TRISIO=0;

	Soft_USART_Init();

	
	while(1){
		GPIO4=1;
		b=get_srf05();
		b=(b*4);

		sprintf(envio,"%d",b);

		for(j=0;j<strlen(envio);j++){
			Soft_USART_Write(envio[j]);
		}
		Soft_USART_Write('\r');
		Soft_USART_Write('\n');

		for(b=0;b<10000;b++);
		GPIO4=0;

	}
}

void delay_104us(void){
	unsigned char o;
	for(o=0;o<6;o++){}
	#asm
		nop
		nop
		nop
	#endasm	
}

void Soft_USART_Init(void){
	Tx=1;
}

void Soft_USART_Write(unsigned char data) {                      
unsigned char mask=1,i;                                                                                  
	mask=0x01;                                                               
	Tx=0; //start bit
	delay_104us();                                                                                                
	for(i=0;i<8;i++){          
		if ((mask & data)!=0) {                                                                                       
			Tx=1;         
		} 
		else {                                                    
			Tx=0;
		}       
	delay_104us();                                                    
	mask=mask <<1; 			                                              
   }
   Tx=1; // stop bit
   delay_104us(); // 9600
}

void send_pulse(void)
{
	OUT;
	TRIG=1; 					
	#asm
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	#endasm
	TRIG=0;
	IN;
}


unsigned int get_srf05(void)
{
	send_pulse();
	TMR1H = 0;								
	TMR1L = 0;	
	T1CON = 0x20;								
	TMR1IF = 0;
	while(!ECHO && !TMR1IF);			
	TMR1ON = 1;								
	while(ECHO && !TMR1IF);				
	TMR1ON = 0;									
	return (TMR1H<<8)+TMR1L;			
}



